import java.io.*;
public final class StatCalc
{
    private StatCalc(){}
    
    public static void main(String[] args)
    {
        try
        {
            if (args.length < 6)
            {
                System.out.println("**Required Parameters**");
                System.out.println("1st: The first level to print, inclusive");
                System.out.println("2rd: The last level to print, inclusive");
                System.out.println("3th: The first job to print, inclusive");
                System.out.println("4th: The last job to print, inclusive");
                System.out.println("5th: The first ability to print, inclusive");
                System.out.println("6th: The last ability to print, inclusive");
            }
            else
            {
                //put stats into an array
                BufferedReader statReader = new BufferedReader(new FileReader("rawStats.csv"));
                int[][] rawStats = new int[4][5];
                String line = statReader.readLine();
                int counter = 0;
                while (line != null)
                {
                    String[] lineArray = line.split(",");
                    for (int n = 0; n < 5; n++)
                    {
                        int stat = Integer.parseInt(lineArray[n]);
                        rawStats[counter][n] = stat;// * 16384;
                    }
                    counter ++;
                    line = statReader.readLine();
                }
                statReader.close();
                
                //put jobs into an array
                BufferedReader jobReader = new BufferedReader(new FileReader("jobs.csv"));
                int[][] jobs = new int[160][10];
                line = jobReader.readLine();
                counter = 0;
                while (line != null)
                {
                    String[] lineArray = line.split(",");
                    for (int n = 0; n < 10; n++)
                    {
                        jobs[counter][n] = Integer.parseInt(lineArray[n]);
                    }
                    counter ++;
                    line = jobReader.readLine();
                }
                jobReader.close();
                
                //put skills into an array
                BufferedReader skillReader = new BufferedReader(new FileReader("abilities.csv"));
                int[][] skills = new int[512][3];
                line = skillReader.readLine();
                counter = 0;
                while (line != null)
                {
                    String lineArray[] = line.split(",");
                    for (int n = 0; n < 3; n++)
                    {
                        skills[counter][n] = Integer.parseInt(lineArray[n]);
                    }
                    counter ++;
                    line = skillReader.readLine();
                }
                skillReader.close();
                
                //Working area is here and down to end of try block
                int levelCounter = Integer.parseInt(args[0]);
                int levelMax = Integer.parseInt(args[1]);
                int jobCounter = Integer.parseInt(args[2]);
                int jobMax = Integer.parseInt(args[3]);
                for (; jobCounter <= jobMax; jobCounter++)
                {
                    int malePA = rawStats[0][3] * 16384;//malepa raw in extended form
                    int jobPAC = jobs[jobCounter][6];//squire pa growth
                    int jobPAM = jobs[jobCounter][7];//squire pa multiplier
                    int jobPA = malePA;
                    
                    int maleMA = rawStats[0][4] * 16384;
                    int jobMAC = jobs[jobCounter][8];
                    int jobMAM = jobs[jobCounter][9];
                    int jobMA = maleMA;
                    
                    System.out.println("Stats    -  HP -  MP -  SP -  PA -  MA");
                    if (levelCounter == 1)
                    {
                        System.out.print(  "Level  1 - ");
                        System.out.print((jobPA * jobPAM) / 1638400);
                        System.out.println();
                        levelCounter++;
                    }
                    for (int i = 2; i < 100; i++)
                    {
                        jobPA = jobPA + (jobPA / (jobPAC + (i - 1)));
                        jobMA = jobMA + (jobMA / (jobMAC + (i - 1)));
                        if (i == levelCounter)
                        {
                            if (i <= 9)
                            {
                                System.out.print("Level  " + i + " - ");
                            }
                            else if (i > 9)
                            {
                                System.out.print("Level " + i + " - ");
                            }
                            System.out.print(((jobPA * jobPAM) / 1638400) + " - ");
                            System.out.print(((jobMA * jobMAM) / 1638400) + " - ");
                            System.out.println();
                            levelCounter++;
                        }
                    }
                    levelCounter = Integer.parseInt(args[0]);
                }
            }
        }
        catch (Exception e)
        {
            System.out.println(e);
            e.printStackTrace();
            System.out.println("\n\n*.csv files must be in the same directory as MakeCSV.class\n\n");
        }
    }
}
